{ (c) Copyright 1995,1997 㭨 .. bunin@mes.djug.pyatigorsk.su }
{$C DemandLoad,Discardable}
Unit Prog2x2;
{$B-,F+,A+,N+,R-,S-,V-,I-,G+,X+,T-}

Interface
Uses Def2x2,x1,Objects,MatrDef,Hash2x2,ExprComp,Calcer,UserFunc;

Type
 PExportRec=^TExportRec;
 TExportRec=record
  TName:TermString;
  NHash:PHashCell
 end;

 PSaveTermBuf=^TSaveTermBuf;
 TSaveTermBuf=record
  OldModule:string[127];
  OldModuleType:TModuleType;
  OldCurY:word;
  OldDataStr:string;
  UserData:pointer;
  Next:PSaveTermBuf;
 end;

 PExportColl=^TExportColl;
 TExportColl=object(TCollection)
  function FindIdent(const IdName:string):PHashCell;
  procedure FreeItem(Item:pointer);virtual;
 end;

 PCompilator=^TCompilator;
 TCompilator=object(TExprCompilator) {  22-ணࠬ }
  DataBlocks:PBlockList;             {   }
  ProgrammCalcer:PBlockCalcer;
  Options2x2:T2x2Options;
  CompModuleType:TModuleType;
  CompModule:string[127];
  constructor Init;
  destructor Done; virtual;
  procedure Translate;virtual;
  procedure Evaluate;virtual;
  function Calculate:PFloat;virtual;
  procedure NewLine; virtual;
  procedure Compile; virtual;
  function GetOutDesc(Num:integer; Var IdDef:TIdDef):boolean;
  function CheckExtern(T:PToken; WhatBlock:byte):boolean; virtual;
  function GetOutNums:word;
  function CreateModuleCompilator(LibraryName:TermString; var LibComp:PCompilator):integer;virtual;
  procedure SwitchInclude(Direction:TSwitchDirection; var Data:pointer);virtual;
  function ExportCount:integer;
  function GetExportDesc(ExpNum:word):IdHandle;
  function FindExportId(IdName:TermString):IdHandle;
  function FindExportFunc(const FuncName:TermString):PUserFuncCalcer;
  function SrcFileExist:boolean;virtual;
  { 㦥 ⮤ }
  function TranslateBlock(WhatBlock:byte):PBlockList;
  procedure SetOwnerCompilator(COwner:PCompilator);
  function FindIdent(const IdName:TermString; var R:pointer):boolean;virtual;
  procedure ValidReference(const ValidName:TermString);virtual;
  procedure AddCreateObj(P:pointer);
 private
  { 㦥 ६ }
  OwnerCompilator:PCompilator;
  Lib2x2Ext:string[4];
  OutList:PListColl;
  Exported:PExportColl;
  InCycle:word;
  { True, ᫨  ࠭ While. -  ஫ Continue,Break.
     ६    - ᢠ  While ⠭- opUknown  }
  CurFuncName:TermString;
  DefsColl:PCollection;
  LibName:PHashCell;
  SaveTB:PSaveTermBuf;
  LibWPList:PCollection;
  LeftObj:P2x2Object;
  LastFormula:PHashCell;             { ᫥ - ᢠ  }
  LastFunc:PHashCell;                { ᫥ - }
  NotCreated:PCollection;
  function TranslateWhile(WhatBlock:byte):PWhileCycle;
  function TranslateIf(WhatBlock:byte):PIfCycle;
  function TranslateCase(WhatBlock:byte):PCaseOp;
  function TranslateCell(What:integer):PArrayCell;
  function TranslateDef(WhatBlock:byte; IsGlobal:boolean):PStructDef;
  function TranslateObjectDef:pointer;
  procedure TranslateFuncDef(P:PBlockList; IsFunc:boolean);
  function TranslateFuncName(LocalHash:PTermHash; IsFunc:boolean):PFunction;
  function TranslatePrint:PBlockList;
  procedure TranslateExtern;
  procedure TranslateObj(P:PObjFormula);
  function TranslateObjExpression(var Back:boolean):PTermTree;
  procedure TranslateList(LMode:ListModeType; UT:OpsType; Coll:PCollection);
  procedure CompileLibrary(LibraryName:TermString; LibHash:PHashCell);
  procedure TransUsesLib(LibHash:PHashCell);
  procedure SaveTermsState;
  procedure RestoreTermsState;
  procedure SwitchToIncludeModule(const InclName:string);
  procedure SwitchToMainModule;
  procedure DoWEP(IsInit:boolean);
  procedure DoneLibs;
  function UnloadLib:boolean;
 end;

 {  ணࠬ, ࠭饩  䠩 }
 PFileCompilator=^TFileCompilator;
 TFileCompilator=object(TCompilator)
  ModuleFile:Text;
  OpenError:integer;
  constructor Init(const FileName:string);
  procedure GetDataString(Var S:string);virtual;
  procedure SwitchInclude(Direction:TSwitchDirection; var Data:pointer);virtual;
  destructor Done; virtual;
  function SrcFileExist:boolean;virtual;
 end;

 {  ணࠬ, ࠭饩  䠩 }
 P2x2Compilator=^T2x2Compilator;
 T2x2Compilator=object(TFileCompilator)
  OutFileName:string;
  OutFile:Text;
  StrPrinted:string;
  constructor Init(const SrcFile,OutputFile:string);
  procedure FlushPrintLine;virtual;
  procedure Print(Var S:string);virtual;
  destructor Done; virtual;
 end;

 {  Library, ࠭饩  䠩 }
 P2x2Library=^T2x2Library;
 T2x2Library=object(TFileCompilator)
  constructor Init(const FileName:string);
  procedure FlushPrintLine;virtual;
  procedure Print(Var S:string);virtual;
 end;

Implementation
Uses TPInline,Diffy,MyString,Dos;

function TExportColl.FindIdent(const IdName:string):PHashCell;
var P:PExportRec;
 function Match(Item:pointer):boolean;far;
 begin
  Match:=PExportRec(Item)^.TName=IdName
 end;
begin
 P:=PExportRec(FirstThat(@Match));
 If P=nil then FindIdent:=nil else FindIdent:=P^.NHash
end;

procedure TExportColl.FreeItem(Item:pointer);
begin
 Dispose(PExportRec(Item))
end;

constructor TCompilator.Init;
begin
 Inherited Init;
 If AutoUnloadLib then Options2x2:=[coCompLib,coAutoUnload]
 else Options2x2:=[coCompLib];
 CompModule:='MAIN';
 CompModuleType:=mtMain;
 Lib2x2Ext:=DefLib2x2Ext;
 SaveTB:=nil;
 CurFuncName:='';
 InCycle:=0;
 OwnerCompilator:=nil;
 ProgrammCalcer:=nil;
 New(DefsColl, Init(10,5));
 DefColl:=DefsColl;
 OutList:=New(PListColl,Init(10,10));
 Exported:=New(PExportColl,Init(32,32));
 LibWPList:=New(PCollection,Init(10,10));
 NotCreated:=New(PCollection,Init(32,32));
end;

function TCompilator.UnloadLib:boolean;
begin
 If (ProgType=pt2x2Library) and (coAutoUnload in Options2x2) then begin
  Dec(LibLoadCount);
  UnloadLib:=LibLoadCount=0
 end
 else UnloadLib:=False
end;

function TCompilator.SrcFileExist:boolean;
begin
 SrcFileExist:=True
end;

function TCompilator.FindIdent(const IdName:TermString; var R:pointer):boolean;
begin
 R:=Exported^.FindIdent(IdName);
 FindIdent:=R<>nil
end;

function TCompilator.ExportCount:integer;
begin
 ExportCount:=Exported^.Count
end;

function TCompilator.GetExportDesc(ExpNum:word):IdHandle;
begin
 If ExpNum>ExportCount then GetExportDesc:=nil
 else GetExportDesc:=PExportRec(Exported^.At(ExpNum-1))^.NHash
end;

function TCompilator.FindExportId(IdName:TermString):IdHandle;
begin
 IdName:=UpperCase(IdName);
 FindExportId:=Exported^.FindIdent(IdName);
end;

function TCompilator.FindExportFunc(const FuncName:TermString):PUserFuncCalcer;
var P:PHashCell;
begin
 P:=FindExportId(FuncName);
 If P=nil then FindExportFunc:=nil
 else
  case P^.TermType of
   opUserFunc,opUserProc: FindExportFunc:=PFunction(P^.HData)^.FuncCalc;
   else FindExportFunc:=nil
  end
end;

procedure TCompilator.AddCreateObj(P:pointer);
begin
 NotCreated^.Insert(p);
end;

function TCompilator.TranslateCell(What:integer):PArrayCell;
{ ࠭  ᢠ - ᨢ }
var P:PArrayCell; ByRef:boolean;
begin
 case TopTerm^.TermType of
  opRefArrayVar,opRefStrArrVar: ByRef:=True;
  else ByRef:=False
 end;
 GetTerm; { 室  [ }
 If TopTerm^.TermType<>opLBrack then EJump1(teLBrackExpected);
 GetTerm;
 P:=NewMemTmp(SizeOf(TArrayCell));

 With P^ do begin
  RefArr:=ByRef;
  TranslateMath(Index,True); { ࠭᫨㥬 1-  }
  Case TopTerm^.TermType of
   opRBrack: Index2.FTree:=nil;
   opComma:
    If What=etArrayCell then begin
     GetTerm;
     TranslateMath(Index2,True) { ࠭᫨㥬 2-  }
    end
  end;

  If TopTerm^.TermType<>opRBrack then EJump1(teRBrackExpected);
  GetTerm; { ய᪠ [ }
  If TopTerm^.TermType<>opAssign then EJump1(teAssignExpected);
  GetTerm; { ய᪠ = }
  If What=etStrArrayCell then begin
   FutureStrError:=teEndExpected;
   TranslateString(FTree)
  end
  else TranslateMath(FTree,True)
 end;
 TranslateCell:=P
end;

function TCompilator.TranslateBlock(WhatBlock:byte):PBlockList;
var BlockNull,P,OldP:PBlockList; LeftHash:PHashCell; LeftToken:PToken; TF:PFormula;
    CheckTerminator,Return:boolean; N,NStruct,NDef,b,b1:word; Op:OpsType; F:PFunction;
{ ࠭  ஢ }
{ CheckTerminator - ஢  ନ- : /: ;  endXXX,  teEndExpected }
 procedure CheckAssign;
 begin
  GetTerm; { 室  = }
  If TopTerm^.TermType<>opAssign then EJump1(teAssignExpected);
  GetTerm; { ய᪠ = }
 end;

 procedure CheckLocation(CheckFunc:boolean; Err:integer);
 var b:boolean;
 begin
  b:=WhatBlock=wbGlobal;
  If not b and CheckFunc then b:=WhatBlock=wbFuncDef;
  If not b then EJump0(Err)
 end;

 procedure DoAssign(Aw:integer);
 var TF:PFormula; Fl:word;
 begin
  LeftHash:=TopTerm^.Ref; { Hash - / PFieldRef }
  Inc(N); { N=᫮ 塞 - }
  P:=NewMemTmp(SizeOf(TBlockList));
  TF:=NewMemTmp(SizeOf(TFormula));
  P^.Expr:=TF;
  TF^.Loc:=LeftHash;
  CheckAssign;
  If Aw<=2 then Fl:=LeftHash^.HFlags else Fl:=PFieldRef(LeftHash)^.FFlags;
  If Fl and off_ReadOnly<>0 then EJump0(teReadOnly);
  { ࠭ ࠢ  }
  case Aw of
   0: begin { Float }
    TranslateMath(TF^.E,True); P^.What:=etFormula;
   end;
   1: begin { string }
    FutureStrError:=teEndExpected;
    TranslateString(TF^.E); P^.What:=etStrFormula
   end;
   2: begin { user type }
    TranslateUser(TF^.E,LeftHash^.What); P^.What:=etFormula;
   end;
   3: begin { float object^ }
    TranslateMath(TF^.E,True); P^.What:=etRefFormula;
   end;
   4: begin { string object^ }
    FutureStrError:=teEndExpected;
    TranslateString(TF^.E); P^.What:=etRefStrFormula
   end;
   5: begin { user type object^ }
    TranslateUser(TF^.E,LeftHash^.What); P^.What:=etRefFormula;
   end;
  end
 end;

 procedure DoConstDef;
 var b:boolean; k:integer; E:PExpressionCalcer;
 begin
  GetTerm; { ய⨬ const }
  b:=True;
  case TopTerm^.TermType of
   opFloatDef: k:=0;
   opStringDef: k:=1;
   opNewVar: begin k:=0; b:=False end;
   else EJump0(teFloatDefExpected)
  end;
  If b then GetTerm;
  case TopTerm^.TermType of
   opNewVar:begin
    DoAssign(k);
    If ExNeed then EJump0(teConstExprExpected);
    LeftHash^.HFlags:=off_ReadOnly;
    case k of
     0: begin
      LeftHash^.TermType:=opFConst;
      E:=New(PExpressionCalcer,Init(PFormula(P^.Expr)^.E));
      LeftHash^.ValueF:=E^.Calculate^;
     end;
     1: begin
      LeftHash^.TermType:=opSConst;
      LeftHash^.ValueP:=NewMem(TextTermSize);
      E:=New(PStrExpressionCalcer,Init(PFormula(P^.Expr)^.E));
      LeftHash^.ValueP^:=PText(E^.Calculate)^;
     end
    end;
    Dispose(E,Done)
   end;
   else EJump1(teOriginNameExpected)
  end;
 end;

 procedure DoMethodDef;
 var Obj:P2x2Object; F:PFunction; LocalHash,Old:PTermHash; OldFuncName:TermString;
     BL:PBlockList; OldProtect:boolean;
 begin
  SearchObjMetod:=True;
  GetTerm; { ய⨬ method }
  SearchObjMetod:=False;
  with TopTerm^ do begin
   If TermType<>opMethodDef then EJump1(teObjectTypeExpected);
   F:=Ref
  end;
  GetTerm;
  If TopTerm^.TermType<>opSemiColon then EJump1(teEndExpected);
  GetTerm; { ய⨬ ; }
  LocalHash:=F^.FuncName^.Nop1;
  Old:=CHash; { - ⥪.  }
  CHash:=LocalHash;
  LocalHash^.Prev:=Old; {  㯠   - ।. ஢ }
  OldFuncName:=CurFuncName;
  CurFuncName:=F^.FuncName^.Name; { -  砩  - }
  Obj:=PMethodCalcer(F^.FuncCalc)^.GetSelfObject;
  OldProtect:=Obj^.GetProtectSwitch;
  Obj^.ProtectFields(False);
  { ࠡ- ⥫ - }
  BL:=TranslateBlock(wbFuncDef);
  Obj^.ProtectFields(OldProtect);
  PMethodCalcer(F^.FuncCalc)^.BuildBlockCalcer(BL);
  with CompError do
   If Error<>0 then ErrorJump(0,cx,cy,Error);
  F^.FuncFlags:=F^.FuncFlags and not ffNotCreated;
  CurFuncName:=OldFuncName;
  CHash:=Old; { - ⥪.  }
  SubrList^.Free(LocalHash); { 㤠塞 . }
  F^.FuncName^.Nop1:=nil;
  case TopTerm^.TermType of
   opEndFunc,opEnd:;
   else EJump0(teEndFuncExpected)
  end;
  GetTerm { ய᪠ opEndFunc }
 end;

 procedure CheckEnd;
 begin
  Case TopTerm^.TermType of
   opSemiColon: GetTerm;
   opEndData..opEnd,opElse:;
   else EJump0(teEndExpected)
  end;
 end;

begin
 N:=0; NDef:=0; NStruct:=0;
 Return:=False;
 BlockNull:=NewMemTmp(SizeOf(TBlockList));
 {    ᯨ᪥ - 㦥; ᮤন ࠧ. -  ᫥ -஢   }
 With BlockNull^ do begin
  What:=etNull; Next:=nil
 end;
 OldP:=BlockNull;
 GetTerm;

 Repeat
  CheckTerminator:=True;

  With TopTerm^ do begin
   Op:=TermType;

   Case Op of
    opFPar..opNewVar:begin { - ᢠ ᫮ ६ }
     DoAssign(0);
     If Op=opNewVar then LeftHash^.TermType:=opFUknown;
     If WhatBlock=wbGlobal then begin
      If not IsDiff then LastFunc:=LeftHash;
      LastFormula:=LeftHash { ᫥ - ᢠ }
     end
    end;

    opArrayVar..opStrArrVar,opRefArrayVar,opRefStrArrVar:begin { - ᢠ - ᨢ }
     LeftHash:=TopTerm^.Ref;
     Inc(N);
     P:=NewMemTmp(SizeOf(TBlockList));
     With P^ do begin
      case Op of
       opStrArrVar,opRefStrArrVar: What:=etStrArrayCell;
       else What:=etArrayCell
      end;
      Expr:=TranslateCell(What);
      PArrayCell(Expr)^.Loc:=LeftHash
     end
    end;

    opSPar..opSUknown: { - ᢠ ப ६ }
     DoAssign(1);

    opIf..opRepeat:begin
     Inc(N);
     P:=NewMemTmp(SizeOf(TBlockList));
     With P^ do begin
      What:=Op-opIf+2;
      GetTerm; { ய᪠ If/While }
      If Op=opWhile then begin
       Inc(InCycle);
       Expr:=TranslateWhile(WhatBlock);
       Dec(InCycle)
      end
      else begin
       Inc(InCycle,$100);
       Expr:=TranslateIf(WhatBlock);
       Dec(InCycle,$100)
      end
     end
    end;

    opEndWhile..opEnd,opElse:
     If WhatBlock=wbGlobal then EJump0(teEIS) { end   祬  ⭮ }
     else begin
      CheckTerminator:=False;
      Return:=True
     end;

    opPrint:begin
     Inc(N);
     P:=NewMemTmp(SizeOf(TBlockList));
     With P^ do begin
      What:=etPrint;
      Expr:=TranslatePrint
     end;
    end;

    opUserVar: DoAssign(2);
    opRefPar: DoAssign(3);
    opRefString: DoAssign(4);
    opRefUser: DoAssign(5);

    opSemiColon,opBegin:begin { ⮩ - }
     GetTerm;
     CheckTerminator:=False
    end;

    opConstDef:begin
     DoConstDef;
     Dec(N);
     CheckEnd;
     CheckTerminator:=False
    end;

    opArrayDef{..opPolinomDef}:begin
     { ᠭ / ⮫쪮    ᠭ -,    If  While }
     CheckLocation(True,teLocArrDef+Op-opArrayDef);
     Inc(NDef); { NDef=᫮ ᠭ }
     {If Op=opArrayDef then} Inc(NStruct);
     { NStruct=᫮ ᠭ ᨢ }
     P:=NewMemTmp(SizeOf(TBlockList));
     With P^ do begin
      {What:=Op-AropetDel;}
      What:=etArrayDef;
      Expr:=TranslateDef(What,WhatBlock=wbGlobal)
     end;
    end;

    opFuncDef,opProcDef:begin
     CheckLocation(True,teLocFuncDef);
     Inc(NDef);
     P:=NewMemTmp(SizeOf(TBlockList));
     With P^ do begin
      What:=etFuncDef;
      TranslateFuncDef(P,Op=opFuncDef)
     end;
    end;

    opParFunc,opParStrFunc,opUserFunc,opStringFunc:begin
     LeftToken:=TopTerm;
     LeftHash:=LeftToken^.Ref;
     Inc(N);
     P:=NewMemTmp(SizeOf(TBlockList));
     If LeftToken^.TermWhat=1 then
      If (CurFuncName<>'') and (CurFuncName=LeftHash^.Name) then F:=PFunction(LeftHash^.HData)
      else F:=PFuncCall(LeftHash)^.Func
     else F:=PFunction(LeftHash^.HData);
     b:=F^.FuncFlags and ffProperty;
     If (CurFuncName<>'') and (F^.FuncName^.Name=CurFuncName) then begin
      { ᢮ - १- - }
      TF:=NewMemTmp(SizeOf(TFormula));
      P^.Expr:=TF;
      TF^.Loc:=LeftToken^.Ref;
      CheckAssign;
      case Op of
       opUserFunc,opParFunc:begin
        P^.What:=etFormula;
        TranslateMath(TF^.E,True)
       end;
       else begin
        FutureStrError:=teEndExpected;
        P^.What:=etStrFormula;
        TranslateString(TF^.E)
       end;
      end
     end
     else begin
      If b=0 then
       With LeftToken^ do begin
        GetTerm; { 砥 = }
        {If TopTerm^.TermType=opAssign then ErrorJump(0,X,Y,teDoubleName)
        else} ErrorJump(1,X,Y,teEIS);
       end;
      { --property }
      TF:=NewMemTmp(SizeOf(TPropFormula));
      P^.Expr:=TF;
      with PPropFormula(TF)^ do begin
       Loc:=LeftHash; { /PFuncCall }
       Func:=F;
       P^.What:=etFuncProp;
       case Op of
        opParFunc,opUserFunc: begin
         TranslateMath(LValue,True);
         If TopTerm^.TermType<>opAssign then EJump1(teAssignExpected);
         GetTerm; { ய᪠ = }
         TranslateMath(RValue,True)
        end;
        else begin
         FutureStrError:=teEndExpected;
         TranslateString(LValue);
         If TopTerm^.TermType<>opAssign then EJump1(teAssignExpected);
         GetTerm; { ய᪠ = }
         TranslateString(RValue);
        end
       end
      end
     end;
    end;

    opUserProc,opParProc,opDirectProc:begin
     Inc(N);
     P:=NewMemTmp(SizeOf(TBlockList));
     TF:=NewMemTmp(SizeOf(TExpression));
     P^.Expr:=TF;
     P^.What:=etProc;
     TranslateMath(PExpression(TF)^,False);
    end;

    opParDef:begin
     CheckLocation(False,teInvParDefLoc);
     TranslateList(lmParList,0,PCollection(ParList));
     CheckTerminator:=False
    end;

    opStringDef:begin
     CheckLocation(True,teInvStringDefLoc);
     TranslateList(lmStringList,0,nil);
     CheckTerminator:=False
    end;

    opCase:begin
     Inc(N);
     P:=NewMemTmp(SizeOf(TBlockList));
     With P^ do begin
      What:=etCase;
      GetTerm; { ய᪠ Case }
      Inc(InCycle,$100);
      Expr:=TranslateCase(WhatBlock);
      Dec(InCycle,$100)
     end
    end;

    opObjectType:begin
     CheckLocation(True,teInvUserObjDefLoc);
     TranslateList(lmUserObjList,TopTerm^.TermWhat,nil);
     CheckTerminator:=False
    end;

    opObject,opRefObject:begin { - ᢠ ꥪ }
     LeftHash:=TopTerm^.Ref; { Hash - / PObjScan }
     b:=TopTerm^.TFlags;
     Inc(N); { N=᫮ 塞 - }
     P:=NewMemTmp(SizeOf(TBlockList));
     TF:=NewMemTmp(SizeOf(TObjFormula));
     with PObjFormula(TF)^ do begin
      Loc:=LeftHash;
      LObj:=TopTerm^.CObjType; LWhatObj:=Op
     end;
     LeftObj:=TopTerm^.CObjType;
     P^.Expr:=TF;
     CheckAssign;
     If b<>0 then EJump0(teReadOnly);
     P^.What:=etObjFormula;
     TranslateObj(PObjFormula(TF)); { ࠭ ࠢ  }
    end;

    opObjectRef,opRefObjectRef:begin { - ᢠ ꥪ }
     LeftHash:=TopTerm^.Ref; { Hash - / PObjScan }
     b1:=TopTerm^.TFlags;
     Inc(N); { N=᫮ 塞 - }
     P:=NewMemTmp(SizeOf(TBlockList));
     TF:=NewMemTmp(SizeOf(TObjFormula));
     with PObjFormula(TF)^ do begin
      Loc:=LeftHash;
      LObj:=TopTerm^.CObjType; LWhatObj:=Op
     end;
     LeftObj:=TopTerm^.CObjType;
     P^.Expr:=TF;
     GetTerm; { 室  =  ^ }
     With TopTerm^ do
      If (TermType=opFunc2) and (TermWhat=moPower) then begin
       b:=0; GetTerm;
      end
      else b:=1;
     If TopTerm^.TermType<>opAssign then EJump1(teAssignExpected);
     If b1<>0 then EJump0(teReadOnly);
     GetTerm; { ய᪠ = }
     If b=0 then begin { Ref^=Obj/Ref^ }
      P^.What:=etObjFormula;
      TranslateObj(PObjFormula(TF)) { ࠭ ࠢ  }
     end
     else begin
      P^.What:=etObjRefAssignFormula;
      with TopTerm^ do
       case TermType of
        opOutSign: begin { Ref=@Obj/Ref=@Obj.Obj }
         GetTerm;
         with TopTerm^ do begin
          case TermType of
           opObject,opRefObject: PObjFormula(TF)^.RWhatObj:=TermType;
           else EJump1(teObjectVarExpected);
          end;
          { Ref / ࠢ   । Obj }
          {If not PUserObject(PHashCell(Ref)^.HData)^.CompatibleObject(CurObjType^.ObjId) then
            ErrorJump(0,X,Y,teUncompatibleObjectVar);}
          TF^.E.FTree:=pointer(Ref); {  PUserObject/PObjScan }
         end
        end;
        opObjectRef,opRefObjectRef: begin { Ref=Ref/Obj.Ref }
         TF^.E.FTree:=pointer(Ref); {  ObjectRef/PObjScan }
         PObjFormula(TF)^.RWhatObj:=TermType;
        end;
        opNil:begin { Ref=nil }
         TF^.E.FTree:=pointer(Ref); {  ObjectRef }
         PObjFormula(TF)^.RWhatObj:=opObjectRef;
        end
        else ErrorJump(1,X,Y,teObjRefExpected);
       end;
      GetTerm
     end
    end;

    opBreak..opExit:begin
     If Op<>opExit then
      { 室  While? }
      If InCycle and $FF=0 then ErrorJump(0,X,Y,teEIS);
     P:=NewMemTmp(SizeOf(TBlockList));
     with P^ do begin
      What:=Op; GetTerm { ய᪠ Break }
     end;
     Inc(N)
    end;

    opUserType:begin
     CheckLocation(True,teInvUserTypeDefLoc);
     TranslateList(lmUserVarList,TopTerm^.TermWhat,nil);
     CheckTerminator:=False
    end;

    opFloatDef:begin
     CheckLocation(True,teInvFloatTypeDefLoc);
     TranslateList(lmFloatVarList,0,nil);
     CheckTerminator:=False
    end;

    opExtern:begin
     If WhatBlock<>wbFuncDef then EJump0(teExternBadLoc);
     TranslateExtern;
     CheckTerminator:=False
    end;

    opMethod:begin
     CheckLocation(False,teLocFuncDef);
     DoMethodDef;
     CheckEnd;
     CheckTerminator:=False
    end;

    opOut:begin
     CheckLocation(False,teInvOutLoc);
     TranslateList(lmOutList,0,PCollection(OutList));
     CheckTerminator:=False
    end;

    opEndData:begin
     CheckLocation(False,teUnexpectedEnd);
     If WhatBlock=wbGlobal then begin
      CheckTerminator:=False;
      If CompModuleType=mtInclude then SwitchToMainModule else Return:=True
     end;
    end;

    opObjectDef:begin
     CheckLocation(False,teInvObjDefLoc);
     Inc(NDef); { NDef=᫮ ᠭ }
     P:=NewMemTmp(SizeOf(TBlockList));
     With P^ do begin
      What:=etObjectDef;
      Expr:=TranslateObjectDef
     end;
    end;

    opInclude:begin
     GetTerm; { ய⨬ Include }
     If TopTerm^.TermType<>opStringConst then EJump1(teStrConstExpected);
     CheckTerminator:=False;
     SwitchToIncludeModule(PString(TopTerm^.Ref)^);
    end;

    opLibDef: begin
     CheckLocation(False,teBadLibDefLoc);
     If (N<>0) or (NDef<>0) or (ProgType=pt2x2Library) then EJump0(teLibDefNotFirst);
     GetTerm; { ய⨬ Library }
     With TopTerm^ do begin
      case TermType of
       opNewVar:
        If PHashCell(Ref)^.Name<>GetModuleName then EJump0(teLibNameMismatch);
       else EJump1(ScanOp(TermType,teOriginNameExpected,teLibNameExpected));
      end;
      LibName:=Ref;
      PHashCell(Ref)^.TermType:=opLib;
     end;
     ProgType:=pt2x2Library;

     GetTerm;
     If TopTerm^.TermType=opResident then begin
      If TermWhat=0 then Include(Options2x2,coAutoUnload)
      else Exclude(Options2x2,coAutoUnload);
      GetTerm
     end;
     CheckTerminator:=False;
     CheckEnd;
    end;

    opDefine:begin
     GetTerm;
     If TopTerm^.TermType<>opNewVar then EJump1(teOriginNameExpected);
     LeftHash:=TopTerm^.Ref;
     GetTerm;
     If TopTerm^.TermType<>opAs then EJump1(teAsExpected);
     GetTerm; { ய⨬ as }
     If LibIdent then LeftHash^.HVal:=TopTerm^.Ref else EJump1(teLibVarExpected);
     GetTerm;
     CheckTerminator:=False;
     CheckEnd;
    end;

    opExport:begin
     CheckLocation(False,teBadExportLoc);
     If ProgType<>pt2x2Library then EJump0(teExportNotInLib);
     TranslateList(lmExportList,0,nil);
     CheckTerminator:=False
    end;

    opUses: begin
     CheckLocation(False,teBadUsesLoc);
     TranslateList(lmUsesList,0,nil);
     CheckTerminator:=False
    end;

    opNextCase:begin
     If (WhatBlock and wbCase=0) or (N<>0) then EJump0(teBadNextCaseLoc);
     P:=BlockNull;
     P^.What:=etCaseNext;
     Return:=True;
     GetTerm { ய᪠ NextCase }
    end;

    else EJump0(teEIS);
   end { case }
  end; { with }

  If CheckTerminator then begin
   CheckEnd;
   P^.Next:=nil;
   OldP^.Next:=P; OldP:=P
  end;
 until Return;

 If (N=0) and (ProgType=pt2x2Program) then
  If WhatBlock=wbGlobal then EJump0(teNoData) {else ErrorJump(0,X,Y,teNoDataInCycle)};

 BlockNull^.NDefBlocks:=NDef;
 BlockNull^.NBlocks:=N;
 BlockNull^.NStructDefs:=NStruct;
 TranslateBlock:=BlockNull
end;

function TCompilator.TranslateWhile(WhatBlock:byte):PWhileCycle;
var P:PWhileCycle;
begin
 P:=NewMemTmp(SizeOf(TWhileCycle));
 With P^ do begin
  NLogCalcs:=0;
  NBraL:=0;
  Logic:=TranslateLogic(False,False);
  NBraL:=0;
  If TopTerm^.TermType<>opDo then EJump0(teDoExpected); { opThen,opBadLog }
  LogCalcs:=NLogCalcs;
  BList:=TranslateBlock((WhatBlock and wbFuncDef)+wbWhile);
  case TopTerm^.TermType of
   opEndWhile,opEnd:;
   else EJump0(teEndWhileExpected);
  end;
  GetTerm
 end;
 TranslateWhile:=P
end;

function TCompilator.TranslateObjectDef:pointer;
var Obj,InhObj:P2x2Object; H,ObjHash:PHashCell; Old,LocalHash:PTermHash;
    b:boolean; i,j,m:integer; t:TObjFieldType; k,FFlag:word; FList:PCollection;
    FOption:TFldOption; SD:PStructDef; F:PFunction; SelfHash:PHashCell;

 procedure SetAttr(Previ:integer);
 var i:integer; H:PHashCell;
 begin
  If FFlag<>0 then begin
   For i:=Previ to FList^.Count-1 do begin
    H:=FList^.At(i);
    H^.HFlags:=FFlag;
    FFlag:=0
   end;
  end
 end;

 procedure TransFuncDef(IsFunc:boolean);
 var OldH,LocalH:PTermHash; w:word;
 begin
  { ᮧ .   ⠢塞   DefColl }
  LocalH:=New(PTermHash, Init(@Self,nil));
  GetHashKey('SELF');
  LocalH^.Search('SELF',True,AllMask,SelfHash);
  with SelfHash^ do begin
   TermType:=opObjectRef; HData:=Obj
  end;
  SubrList^.Insert(LocalH);
  OldH:=CHash; { - ⥪.  }
  PObjDefHash(OldH)^.EnableFuncEq:=True;
  { ࠡ- ᠭ - }
  F:=TranslateFuncName(LocalH,IsFunc);
  PObjDefHash(OldH)^.EnableFuncEq:=False;
  F^.FuncCalc:=nil;
  case F^.FuncName^.TermType of
   opUserFunc: w:=ffFloatFunc;
   opStringFunc: w:=ffStrFunc;
   opUserProc: w:=ffProc;
  end;
  F^.FuncFlags:=F^.FuncFlags or w or ffAsMethodEnable or ffNotCreated;
  F^.FuncName^.Nop1:=LocalH;
  CHash:=OldH; { - ⥪.  }
 end;

begin
 GetTerm; { ய⨬ Object }
 H:=TopTerm^.Ref;
 with TopTerm^ do
  If TermType=opNewVar then begin
   H^.TermType:=opObjectType;
   ObjHash:=H
  end
  else EJump1(teDoubleName);

 GetTerm;
 If TopTerm^.TermType=opLBra then begin
  GetTerm; { ய⨬ ( }
  H:=TopTerm^.Ref;
  If TopTerm^.TermType<>opObjectType then EJump1(teObjectTypeExpected);
  InhObj:=H^.HData;
  GetTerm;
  If TopTerm^.TermType<>opRBra then EJump1(teRBraExpected);
  GetTerm { ய⨬ ) }
 end
 else InhObj:=User2x2TObject;

 { ᮧ .   ⠢塞   DefColl }
 LocalHash:=New(PObjDefHash, Init(@Self,CHash));
 FList:=PObjDefHash(LocalHash)^.FieldsList;
 PObjDefHash(LocalHash)^.InhObj:=InhObj;
 DefColl^.Insert(LocalHash);
 Old:=CHash; { - ⥪.  }
 CHash:=LocalHash;
 FFlag:=0;

 If ProgType=pt2x2Program then k:=GetFreeObjId+opObjType2
 else k:=Manager2x2^.GetFreeObjId+opObjType3;
 Obj:=New(P2x2Object,Init(ObjHash^.Name,k,InhObj));
 If ProgType<>pt2x2Program then Obj^.SetWhoCreate(Manager2x2);
 SubrList^.Insert(Obj);

 While True do begin
  j:=FList^.Count;
  case TopTerm^.TermType of
   opFloatDef:begin
    TranslateList(lmFloatVarList,0,nil);
    SetAttr(j)
   end;
   opStringDef:begin
    TranslateList(lmStringList,0,nil);
    SetAttr(j)
   end;
   opObjectType:begin
    TranslateList(lmUserObjList,TopTerm^.TermWhat,@j);
    SetAttr(j)
   end;
   opUserType:begin
    TranslateList(lmUserVarList,TopTerm^.TermWhat,nil);
    SetAttr(j)
   end;
   opEnd: break;
   opFieldAtr: begin
    FFlag:=FFlag or TopTerm^.TermWhat;
    GetTerm;
    continue
   end;
   opArrayDef:begin
    SD:=TranslateDef(etArrayDef,False);
    SD^.ArrDef^.Extern:=True;
    SetAttr(j)
   end;
   opFuncDef,opProcDef:begin
    TransFuncDef(TopTerm^.TermType=opFuncDef);
    FOption:=[];
    If FFlag and off_Protected<>0 then Include(FOption,offProtected);
    If FFlag and off_Virtual<>0 then Include(FOption,offVirtual);
    m:=Obj^.AddMethodPrim(F,F^.FuncName^.Name,FOption);
    If m=0 then begin
     F^.FuncCalc:=New(PMethodCalcer,Init(F));
     PMethodCalcer(F^.FuncCalc)^.SetObjHash(SelfHash);
    end
    else EJump0(m);
    FFlag:=0;
   end;
   else EJump1(teEIS)
  end;

  case TopTerm^.TermType of
   opSemiColon: If FFlag<>0 then EJump0(teObjFldIdExpected);
   opEnd: If FFlag<>0 then EJump0(teObjFldIdExpected) else break;
   else EJump0(teEndExpected);
  end;
  GetTerm
 end;

 CHash:=Old; { - ⥪.  }
 GetTerm; { ய⨬ end }

 For i:=0 to FList^.Count-1 do
  with Obj^ do begin
   H:=FList^.At(i);
   FOption:=[];
   If H^.HFlags and off_Protected<>0 then Include(FOption,offProtected);
   If H^.HFlags and off_ReadOnly<>0 then Include(FOption,offReadOnly);
   If H^.HFlags and off_Virtual<>0 then Include(FOption,offVirtual);
   case H^.TermType of
    opFUknown: t:=dctFloat;
    opSUknown: t:=dctString;
    opUserVar: t:=H^.What;
    opObject:begin
     b:=AddObjectField(H^.Name,H^.HData,FOption);
     continue
    end;
    opObjectRef:begin
     b:=AddObjectRefField(H^.Name,H^.HData,FOption);
     continue
    end;
    opStrArrVar:begin
     If AddField(H^.Name,dctStrArray,FOption) then
      with PStructDef(H^.HData)^ do
       DefineArray(FindByName(H^.Name),ArrDef^.Size1,longint(Data));
     continue
    end;
    opArrayVar:begin
     If AddField(H^.Name,dctArray,FOption) then
      with PStructDef(H^.HData)^.ArrDef^ do
       DefineArray(FindByName(H^.Name),Size1,Size2);
     continue
    end;
   end;
   b:=AddField(H^.Name,t,FOption);
  end;

 ObjHash^.HData:=Obj;
 ObjHash^.What:=Obj^.ObjId;
 DefColl^.Free(LocalHash); { 㤠塞 . }
 TranslateObjectDef:=Obj;
 Obj^.ProtectFields(False);
end;

function TCompilator.TranslateDef(WhatBlock:byte; IsGlobal:boolean):PStructDef;
var A:PStructDef; CL,OldCL:PCellList; NameTerm:TToken; b:boolean; t,i:byte;
    SizeVal:TExpression;

function CalcSize(var Exp:TExpression):word;
const maxword=$FFF0;
var E:PExpressionCalcer; x:Float;
begin
 E:=New(PExpressionCalcer,Init(Exp));
 x:=E^.Calculate^;
 Dispose(E,Done);
 If NotNumber(x) or (x<=0) or (x>maxword) then
  with Exp do ErrorJump(0,LocX,LocY,teInvArraySize);
 CalcSize:=Round(x)
end;

begin
 GetTerm; { ய᪠ Array/Polinom }
 Dec(WhatBlock,wbArrayDef);
 A:=NewMem(SizeOf(TStructDef));
 A^.ArrDef:=NewMemTmp(SizeOf(TArrayDef));

 If TopTerm^.TermType<>opLBrack then EJump0(teLBrackExpected);
 CHash^.EnablePrevLevel(True); { ࠧ訬    ⠭⠬ }
 GetTerm; { ய᪠ [ }

 { ࠭᫨㥬 ࠧ୮ }
 With A^,A^.ArrDef^ do begin
  TranslateMath(SizeVal,True); { - ࠧ }
  If ExNeed then { ࠧ -  ⠭⭮ ࠦ }
   With SizeVal do ErrorJump(0,LocX,LocY,teParInSizeVal);
  Size1:=CalcSize(SizeVal);

  Case TopTerm^.TermType of
   opRBrack: Size2:=0;
   opComma:
    If (WhatBlock=0) then begin
     GetTerm;
     TranslateMath(SizeVal,True);
     If ExNeed then With SizeVal do ErrorJump(0,LocX,LocY,teParInSizeVal);
     Size2:=CalcSize(SizeVal);
    end
  end;
 end;
 CHash^.EnablePrevLevel(False);

 If TopTerm^.TermType<>opRBrack then EJump0(teRBrackExpected);
 GetTerm; { ய᪠ ] }

 If WhatBlock=0 then begin { ᨢ,  Polinom }
  { - ⨯ - }
  Case TopTerm^.TermType of
   opSimm: begin t:=SimmM; GetTerm end;
   opDiag: begin t:=DiagM; GetTerm end;
   else t:=GeneralM
  end;

  With A^.ArrDef^ do
   If Size2<>0 then
    If (t<>GeneralM) and (Size1<>Size2) then
     with SizeVal do ErrorJump(0,LocX,LocY,teDimNotEqual);

  If TopTerm^.TermType=opOf then begin
   GetTerm; { ய᪠ of }
   If TopTerm^.TermType=opStringDef then begin
    If t<>GeneralM then EJump0(teStrArNoGeneral);
    GetTerm; { ய᪠ string }
    If TopTerm^.TermType<>opLBrack then i:=TextTermSize-1
    else begin
     GetTerm; { ய᪠ [ }
     With TopTerm^ do begin
      If (TermType<>opConst) or (Frac(PFloat(Ref)^)<>0) then EJump1(teConstExpected);
      If (PFloat(Ref)^<1) or (PFloat(Ref)^>TextTermSize-1) then EJump0(teInvStrLenDef);
      i:=Round(PFloat(Ref)^);
      GetTerm; { 室  ] }
      If TopTerm^.TermType<>opRBrack then EJump0(teRBrackExpected);
      GetTerm; { ய᪠ ] }
     end
    end;
    t:=StringM;
    longint(A^.Data):=longint(i);
   end
   else EJump1(teStringDefExpected)
  end
 end;

 NameTerm:=TopTerm^;
 case TopTerm^.TermType of
  opNewVar:;
  else EJump1(ScanOp(TopTerm^.TermType,teOriginNameExpected,teArrayNameExpected+WhatBlock));
 end;

 With NameTerm do begin
  { 塞  opNewVar  opArrayVar,opPolinom ⮫쪮 ᫥  }
  { TransFormula: ࠭  訡 ⨯ "Array A[ 2*A[1] ]" }
  If t=StringM then PHashCell(Ref)^.TermType:=opStrArrVar
  else PHashCell(Ref)^.TermType:=opArrayVar+WhatBlock;
  PHashCell(Ref)^.HData:=A
 end;

 With A^,A^.ArrDef^ do begin
  NameHash:=PHashCell(NameTerm.Ref);
  CellList:=nil; Cells:=0; Extern:=False;
  MType:=t;
  GetTerm; { ய᪠  }
 end;

 With TopTerm^ do
  If TermType<>opAssign then begin {  -樨 }
   If (WhatBlock=1) and IsGlobal then EJump0(teAssignExpected); { Polinom / ந- }
   TranslateDef:=A;
   exit
  end
  else
   If not IsGlobal and (WhatBlock=1) then EJump0(teEndExpected);
 GetTerm; { ய᪠ = }

 With A^,A^.ArrDef^ do begin
  b:=False;
  CL:=NewMemTmp(SizeOf(TCellList));
  CellList:=CL; OldCL:=CL;

  If TopTerm^.TermType=opExtern then begin
   { ஢塞,    ⠪ ᨢ/ }
   If not CheckExtern(@NameTerm,WhatBlock+wbArrayDef) then
    with NameTerm do ErrorJump(0,X,Y,teNotExternAr+WhatBlock);
   Extern:=True;
   TranslateDef:=A;
   GetTerm  { ய᪠ Extern }
  end
  else begin
   If IsGlobal=False then
    with ATerms[not CurTerm] do ErrorJump(0,X,Y,teEndArrDefExpected);
   Repeat
    CL:=NewMemTmp(SizeOf(TCellList));
    Inc(Cells);

    With CL^ do begin
     Next:=nil;
     If t=StringM then begin { - of string }
      TranslateString(F);
      If ExNeed then { 祭 -  ᫨ }
       with F do ErrorJump(0,LocX,LocY,teParInCellVal);
     end

     else begin { - of float }
      TranslateMath(F,True);
      If ExNeed then { 祭 -  ᫨ }
       with F do ErrorJump(0,LocX,LocY,teParInCellVal);
     end;
    end;

    OldCL^.Next:=CL; OldCL:=CL;
    case TopTerm^.TermType of
     opSemiColon: b:=True;
     opComma: GetTerm;
     else EJump1(teEndExpected)
    end;
   until b
  end
 end;
 TranslateDef:=A
end;

function TCompilator.TranslateIf(WhatBlock:byte):PIfCycle;
var P:PIfCycle;
begin
 P:=NewMemTmp(SizeOf(TIfCycle));
 With P^ do begin
  NLogCalcs:=0;
  NBraL:=0;
  { ࠭᫨㥬 ᫮ }
  Logic:=TranslateLogic(False,False);
  NBraL:=0;
  With TopTerm^ do begin
   Case TermType of
    opThen: ;
    else EJump0(teThenExpected); { opDo,opBadLog }
   end;
   LogCalcs:=NLogCalcs;
   { ࠭᫨㥬 ⥫ If }
   BListIf:=TranslateBlock((WhatBlock and wbFuncDef)+wbIf)
  end;
  case TopTerm^.TermType of
   opEndIf,opEnd: GetTerm; { ய᪠ opEndIf }
   opElse:;
   else EJump0(teEndIfExpected);
  end;

  If TopTerm^.TermType=opElse then begin
   { ࠭᫨㥬 ⥫ Else }
   BListElse:=TranslateBlock(wbElse);
   case TopTerm^.TermType of
    opEndElse,opEnd:;
    else EJump0(teEndElseExpected);
   end;
   GetTerm; { ய᪠ opEndElse }
  end
  else BListElse:=nil
 end;
 TranslateIf:=P
end;

function TCompilator.TranslateCase(WhatBlock:byte):PCaseOp;
var P:PCaseOp; W,i:integer; Q:PCaseList; b:boolean;
begin
 P:=NewMemTmp(SizeOf(TCaseOp));
 With P^ do begin
  ElseBlock:=nil;
  { ࠭᫨㥬 ࠦ }
  case TopTerm^.TermType of
   opStrArrVar,opStringConst,opSPar..opSConst,opParStrFunc,opStringFunc,
   opDirectStrFunc,opRefString,opRefStrArrVar:
   begin
    W:=1; WhatCase:=etStrFormula;
    TranslateString(CaseExpr);
   end
   else begin
    W:=0; WhatCase:=etFormula;
    TranslateMath(CaseExpr,True)
   end
  end;
  If TopTerm^.TermType<>opOf then EJump0(teOfExpected);
  GetTerm; { ய⨬ of }

  Q:=NewMemTmp(SizeOf(TCaseList));
  Cases:=Q;
  i:=0;
  b:=False;

  While True do begin
   With TopTerm^ do
    Case TermType of
     opElse: begin
      If i=0 then EJump0(teEmptyCaseWE);
      If ElseBlock<>nil then EJump0(teEndCaseExpected);
      ElseBlock:=TranslateBlock(wbElse);
      case TopTerm^.TermType of
       opEndElse,opEnd:;
       else EJump0(teEndElseExpected);
      end;
      GetTerm; { ய᪠ opEndElse }
      With TopTerm^ do
       If TermType=opSemiColon then GetTerm; { ய⨬ ; }
     end;

     opEnd,opEndCase: begin
      If i=0 then EJump0(teEmptyCase);
      GetTerm; { ய⨬ EndCase }
      break
     end;

     else begin
      If ElseBlock<>nil then EJump0(teEndCaseExpected);
      If b then begin
       Q^.Next:=NewMemTmp(SizeOf(TCaseList));
       Q:=Q^.Next
      end
      else b:=True;
      Q^.Next:=nil;

      If TermType=opRel then begin
       Q^.RelWhat:=TermWhat;
       GetTerm
      end
      else Q^.RelWhat:=rtE;

      If W=1 then TranslateString(Q^.CaseValue)
      else TranslateMath(Q^.CaseValue,True);
      If TopTerm^.TermType<>opColon then EJump0(teColonExpected);

      Q^.CaseBlock:=TranslateBlock((WhatBlock and wbFuncDef)+wbCase);
      case TopTerm^.TermType of
       opEndSwitch,opEnd:;
       else EJump0(teEndSwitchExpected);
      end;
      GetTerm; { ய᪠ opEndSwitch }
      If TopTerm^.TermType=opSemiColon then GetTerm; { ய⨬ ; }
      Inc(i);
     end
    end
  end;
  NCases:=i;
 end;
 TranslateCase:=P
end;

procedure TCompilator.TranslateExtern;
var O,H:PHashCell;
begin
 Repeat
  GetTerm; { 砥  }
  If TopTerm^.TermType<>opNewVar then EJump1(teLocAsGlobal);
  O:=TopTerm^.Ref; { Hash  . Hash-⠡ }
  If CHash^.Prev^.Search(O^.Name,False,AllMask and not FuncMask,H) then O^.HVal:=H
  else EJump0(teNotExistInGlobal);
  GetTerm; { ய᪠  }
  Case TopTerm^.TermType of
   opComma:;
   opSemiColon: break;
   else EJump1(teEndExpected);
  end
 until False
end;

procedure TCompilator.TranslateFuncDef(P:PBlockList; IsFunc:boolean);
var Old,LocalHash:PTermHash; OldFuncName:TermString;
begin
 { ᮧ .   ⠢塞   DefColl }
 LocalHash:=New(PTermHash, Init(@Self,nil));
 DefColl^.Insert(LocalHash);
 Old:=CHash; { - ⥪.  }

 { ࠡ- ᠭ - }
 P^.Expr:=TranslateFuncName(LocalHash,IsFunc);
 LocalHash^.Prev:=Old; {  㯠   - ।. ஢ }

 OldFuncName:=CurFuncName; { -  砩  - }

 {  ⥪. -: -  ஫ ᢠ - - }
 { e.g. 'Func A(...); A=5... end;' ,  B=5,  B-⮦ - - }
 CurFuncName:=PFunction(P^.Expr)^.FuncName^.Name;
 { ࠡ- ⥫ - }
 PFunction(P^.Expr)^.FuncCalc:=TranslateBlock(wbFuncDef);
 CurFuncName:=OldFuncName;
 CHash:=Old; { - ⥪.  }
 { 㤠塞 . . ᫨  - -  ErrorJump, 
    㤥 㤠 ⥬ Dispose(DefColl, Done) }
 DefColl^.Free(LocalHash); { 㤠塞 . }

 case TopTerm^.TermType of
  opEndFunc,opEnd:;
  else EJump0(teEndFuncExpected)
 end;
 GetTerm { ய᪠ opEndFunc }
end;

function TCompilator.TranslateFuncName(LocalHash:PTermHash; IsFunc:boolean):PFunction;
var Main,P,H:PHashCell; F,Fp:PFunction; VarPar,b1,b2:boolean; Op,i:OpsType;
    s:string[1]; Er:integer;

 procedure AAA(Var Fn:PFunction; AIsFunc:boolean); { ࠡ⪠  - }
 var Old:PTermHash;
 begin
  Old:=CHash^.Prev;
  CHash^.Prev:=nil;
  GetTerm; { 砥  -; 㤥 ᥭ  GlobalHash  }
           {  -   LocalHash   -      }
  CHash^.Prev:=Old;
  With TopTerm^ do begin
   Case TermType of {  - 㭨쭮? }
    opNewVar: ; {  }
    else EJump1(ScanOp(TermType,teDoubleName,teFuncNameExpected));
   end;
   P:=Ref; { Hash  }
   P^.What:=0;
   { ॣ㥬  -  ⥪.  }
   If AIsFunc then P^.TermType:=opUserFunc else P^.TermType:=opUserProc;
  end;

  GetTerm; { 砥 ( }
  If TopTerm^.TermType<>opLBra then EJump0(teLBraExpected);

  Fn:=NewMem(SizeOf(TFunction));
  FillChar(Fn^,SizeOf(TFunction),0);
  P^.HData:=Fn; {  Hash  - 㪠-  ᠭ - }
  With Fn^ do begin
   FuncName:=P; { Hash  - }
  end
 end;

 procedure ValidNPars(Fn:PFunction; ParType:OpsType; ParHash:PHashCell);
 begin
  with Fn^ do begin
   Inc(NPars);
   If NPars>MaxFuncPars then EJump0(teTooManyPars);
   If VarPar then Inc(NParVars);
   with Pars[NPars] do begin
    TermType:=ParType; Hash:=ParHash
   end
  end;
 end;

begin
 AAA(F,IsFunc); { ࠡ-  ॣ-  - }
 If IsFunc then begin
  { 㡫㥬  -  LocalHash   祭 -) }
  LocalHash^.Search(P^.Name,True,AllMask,H);
  H^.TermType:=opUserFunc;
  H^.HData:=F;
  F^.FuncName:=H;
  H^.What:=0;
 end;

 Main:=P;
 CHash:=LocalHash;

 GetTerm; { ய᪠ ( }
 B1:=False; Er:=0;

 Repeat { 横  ࠬࠬ }
  VarPar:=(TopTerm^.TermType=opOutSign) or (TopTerm^.TermType=opVarDef);
  {  @/Var ।  - ᫥ ।-  뫪 }
  If VarPar then GetTerm; { ய᪠ @/Var }

  With TopTerm^ do begin
   Op:=TermType;
   Case Op of
    opNewVar:begin { --६ }
     PHashCell(Ref)^.TermType:=opFUknown;
     If VarPar then i:=opFPar else i:=opFUknown; { ⮡ ६  뫮 ᮪ }
     ValidNPars(F,i,Ref);
    end;

    opArrayDef..opMatrixDef:begin
     VarPar:=False;
     GetTerm; { ய᪠ Array/Polinom/Matrix }
     If TopTerm^.TermType=opOf then begin
      GetTerm; { ய᪠ Of }
      If TopTerm^.TermType<>opStringDef then EJump0(teStringDefExpected);
      GetTerm; { ய᪠ string }
      i:=opStrArrVar
     end
     else i:=Op-OpArDel;
     With TopTerm^ do
      case TermType of {  - 㭨쭮? }
       opNewVar:begin
        PHashCell(Ref)^.TermType:=i;
        { ᮧ PStructDef,  Data ன 㤥 । 䠪. - Data }
        PHashCell(Ref)^.HData:=NewMem(SizeOf(TStructDef));
        ValidNPars(F,i,Ref);
       end;
       else Er:=ScanOp(TermType,teDoubleName,teVarNameExpected);
      end
    end;

    opFuncDef,opProcDef:begin { - - - }
     B2:=False;
     VarPar:=False;
     AAA(Fp,Op=opFuncDef);
     If Op=opFuncDef then P^.TermType:=opParFunc else P^.TermType:=opParProc;
     If Op=opFuncDef then i:=opUserFunc else i:=opUserProc;
     ValidNPars(F,i,Fp^.FuncName);
     GetTerm; { ய᪠ Func }

     Repeat { 横  - }
      VarPar:=False;
      With TopTerm^ do
       Case TermType of
        opFunc2:
         If TermWhat=moMult then { * - ᫮ ६ }
          with Fp^ do ValidNPars(Fp,opFUknown,nil)
         else Er:=teFuncSignsExpected;

        opOutSign:begin { @ - ᫮ ६-뫪 }
         VarPar:=True;
         ValidNPars(Fp,opFPar,nil);
        end;

        opStringDef: ValidNPars(Fp,opSUknown,nil);

        opArrayDef..opPolinom: ValidNPars(Fp,TopTerm^.TermType-OpArDel,nil);

        opRBra:
         { ᫥ ⮩ / ᨬ - }
         If Fp^.NPars<>0 then Er:=teFuncSignsExpected
         else break; { -  - }

        else Er:=teFuncSignsExpected;
       end; { case }
      If Er<>0 then break;

      GetTerm;
      Case TopTerm^.TermType of
       opComma: GetTerm; { 室  ᫥. - }
       opRBra: b2:=True;
       else EJump0(teCommaExpected);
      end;
     until b2;
     Fp^.MinFactArgs:=Fp^.NPars;
    end;

    opStringDef,opUserType,opObjectType:begin
     If Op=opObjectType then Fp:=TopTerm^.Ref; { ६ - Fp }
     GetTerm; { ய᪠ string/opUserType/opObjectType }
     If Op=opObjectType then
      If (TopTerm^.TermType=opFunc2) and (TopTerm^.TermWhat=moPower) then begin
       i:=opObjectRef;
       GetTerm { ய⨬ ^ }
      end
      else i:=opObject;

     With TopTerm^ do
      case TermType of
       opNewVar:begin
        With PHashCell(Ref)^ do begin
         If Op=opStringDef then begin
          TermType:=opSPar;
          ValueP:=NewMem(TextTermSize);
          If VarPar then i:=opSPar else i:=opSUknown;
         end
         else
         If Op=opObjectType then begin
          TermType:=i;
          What:=PHashCell(Fp)^.What;
          ValueP:=PHashCell(Fp)^.HData;
          If i=opObject then begin
           HData:=CreateObjInstance(P2x2Object(ValueP));
           DefColl^.Insert(HData);
          end
          else HData:=ValueP; { P2x2Object }
         end
         else begin
          TermType:=opUserVar;
          What:=ATerms[not CurTerm].TermWhat;
          If VarPar then i:=opUserPar else i:=opUserVar;
         end
        end;
        ValidNPars(F,i,Ref);
        If Op=opObjectType then
         With F^ do Pars[NPars].UTFlag:=word(VarPar); { utfByPar  VarPar=True }
       end;
       else Er:=ScanOp(TermType,teDoubleName,teVarNameExpected);
      end
    end;

    opRBra:
     If VarPar then Er:=teVarNameExpected else break;

    else Er:=ScanOp(Op,teDoubleName,teVarNameExpected);
   end; { case }
   If Er<>0 then EJump1(Er);

   GetTerm;
   Case TopTerm^.TermType of
    opComma: GetTerm; { 室  ᫥. - }
    opRBra: b1:=True;
    else EJump0(teCommaExpected);
   end;
  end;
 until b1;

 F^.MinFactArgs:=F^.NPars;
 GetTerm;
 If IsFunc and (TopTerm^.TermType=opColon) then begin { - ⨯ string }
  GetTerm; { ய᪠ : }
  If TopTerm^.TermType=opStringDef then begin
   H^.TermType:=opStringFunc;
   Main^.TermType:=opStringFunc;
   {    - ।-   ப }
   H^.ValueP:=NewString(S,False)
  end
  else EJump1(teStringDefExpected);
  GetTerm { ய᪠ string }
 end;

 If TopTerm^.TermType<>opSemiColon then EJump1(teEndExpected);
 TranslateFuncName:=F
end;

function TCompilator.TranslatePrint:PBlockList;
var b,ExpFormat,Co:boolean; BlockNull,OldP,P:PBlockList; TP:PPrintRec; N:word; i1,i2:integer;

 procedure GetFormat(var i:integer);
 var E:Float; cod:integer;
 begin
  GetTerm;
  With TopTerm^ do begin
   If TermType<>opConst then EJump1(teConstExpected);
   E:=PFloat(Ref)^;
   If Frac(E)<>0 then EJump0(teConstExpected);
   If (E<0) or (E>30) then EJump0(teInvFormat);
   i:=Round(E)
  end
 end;

begin
 N:=0; b:=False;
 BlockNull:=NewMemTmp(SizeOf(TBlockList));
 OldP:=BlockNull;
 OldP^.Next:=nil;
 FutureStrError:=teRBraExpected;

 GetTerm; { 室  ( }
 If TopTerm^.TermType<>opLBra then EJump0(teLBraExpected);

 NBraL:=1;
 Co:=False;

 Repeat
  GetTerm;
  With TopTerm^ do
   case TermType of
    opRBra:
     If Co then
      with ATerms[not CurTerm] do ErrorJump(0,X,Y,teCommaUnnecessary)
     else break; { ᯨ᮪  }

    opStringConst,opSPar..opSConst,opParStrFunc,opStringFunc,opDirectStrFunc,
    opStrArrVar,opRefString,opRefStrArrVar:begin
     TP:=NewMemTmp(SizeOf(TPrintRec));
     TranslateString(TP^.F);
     P:=NewMemTmp(SizeOf(TBlockList));
     Inc(N);
     P^.What:=etStrFormula;
     P^.Expr:=TP;
    end;

    else begin
     TP:=NewMemTmp(SizeOf(TPrintRec));
     TranslateMath(TP^.F,True);
     P:=NewMemTmp(SizeOf(TBlockList));
     Inc(N);
     P^.What:=etFormula;
     P^.Expr:=TP;

     i1:=$FF; i2:=$FF; ExpFormat:=False;
     If TopTerm^.TermType=opColon then begin
      GetFormat(i1);
      GetTerm;
      If TopTerm^.TermType=opColon then begin
       GetFormat(i2); GetTerm
      end
     end;

     If i1=$FF then begin
      i1:=stFormat1; i2:=stFormat2
     end
     else
      If i2=$FF then begin
       ExpFormat:=True;
       If i1>26 then i1:=26
       else
        If i1<10 then i1:=10
      end
      else begin
       If i1<2 then i1:=2;
       If i1-i2<2 then i2:=0
      end;

     With TP^ do begin
      Expo:=ExpFormat; F1:=i1; F2:=i2
     end
    end
   end; { case }

  Co:=False;
  case TopTerm^.TermType of
   opComma: Co:=True;
   opRBra: b:=True;
   else EJump0(teRBraExpected)
  end;

  OldP^.Next:=P;
  P^.Next:=nil; OldP:=P
 until b;

 NBraL:=0;
 TransError:=0;
 GetTerm; { ய᪠ ) }
 BlockNull^.NBlocks:=N;
 TranslatePrint:=BlockNull
end;

procedure TCompilator.TranslateObj(P:PObjFormula);
var Op:OpsType; T:PTermTree; Back:boolean;
begin
 With P^.E do begin
  With TopTerm^ do begin
   LocX:=X; LocY:=Y
  end;
  NCalcs:=0; NBraE:=0; NBrack:=0;
  Back:=False;
  FTree:=TranslateObjExpression(Back);
  If NCalcs=0 then NCalc:=1 else NCalc:=NCalcs;
 end
end;

function TCompilator.TranslateObjExpression(var Back:boolean):PTermTree;
{  ࠦ  ꥪ⠬ }
var b:boolean; P,K:PTermTree; Op,Op1:OpsType; i:integer;
begin
 With TopTerm^ do begin
  Op:=TermType; Op1:=Op;
  GetTerm;
  Case Op of
   opLBra:begin
    Inc(NBraE);
    P:=TranslateObjExpression(Back);
    CheckRBra; Dec(NBraE);
   end;

   opObject,opRefObject: begin
    If Op=opRefObject then Inc(NCalcs);
    Op:=P2x2Object(CObjType)^.ObjId;
    { ⨯ ꥪ⮢    ࠢ   ᢠ ࠧ }
    If LeftObj^.ObjId<>Op then begin
     { ꥪ ᮢ⨬ ? }
     b:=P2x2Object(CObjType)^.ObjectIsParent(LeftObj^.ObjId);
     { ꥪ ᮢ⨬ (b=False)    . 
       ࠧ묨 ⨯ ꥪ⮢ (Back=True) }
     If Back or not b then ErrorJump(0,X,Y,teUncompatibleObjectVar);
     Back:=True;
    end;
    P:=NewMemTmp(SizeOf(TTermTree));
    with P^ do begin
     TermType:=Op1; WhatR:=Ref { PUserObject/PObjScan }
    end;
   end;

   opObjectRef,opRefObjectRef: begin
    If (TopTerm^.TermType=opFunc2) and (TopTerm^.TermWhat=moPower) then
    else EJump1(teRefExpected);
    Op:=P2x2Object(CObjType)^.ObjId;
    { ⨯ ꥪ⮢    ࠢ   ᢠ ࠧ }
    If LeftObj^.ObjId<>Op then begin
     { ꥪ ᮢ⨬ ? }
     b:=P2x2Object(CObjType)^.ObjectIsParent(LeftObj^.ObjId);
     { ꥪ ᮢ⨬ (b=False)    . 
       ࠧ묨 ⨯ ꥪ⮢ (Back=True) }
     If Back or not b then ErrorJump(0,X,Y,teUncompatibleObjectVar);
     Back:=True;
    end;
    P:=NewMemTmp(SizeOf(TTermTree));
    with P^ do begin
     If Op1=opRefObjectRef then begin
      Inc(NCalcs); TermType:=opRefObject;
     end
     else TermType:=opObject;
     WhatR:=Ref
    end;
    GetTerm
   end;

   opFunc1:begin { 㭠ୠ  }
    {  -  ꥪ ? }
    If not LeftObj^.IsDefFunction(TermWhat) then ErrorJump(0,X,Y,teFuncNotEnable);
    {  ࠦ  /   樨 }
    If Back then ErrorJump(0,X,Y,teUnderObjOps);
    Inc(NCalcs);
    P:=NewMemTmp(SizeOf(TTermTree));
    with P^ do begin
     TermType:=Op; What:=TermWhat
    end;
    CheckLBra;
    Inc(NBraE);
    Back:=True;
    P^.Head:=TranslateObjExpression(Back);
    CheckRBra; Dec(NBraE);
   end;

   opFunc2:begin { 㭠  }
    If TermWhat=moMinus then begin
     If not LeftObj^.IsDefFunction(f1Neg) then ErrorJump(0,X,Y,teFuncNotEnable);
     If Back then ErrorJump(0,X,Y,teUnderObjOps);
     Inc(NCalcs);
     P:=NewMemTmp(SizeOf(TTermTree));
     With P^ do begin
      What:=f1Neg; TermType:=opFunc1;
      Back:=True;
      Head:=TranslateObjExpression(Back);
     end
    end
    else ErrorJump(0,X,Y,teEIE)
   end;

   else begin
    case Op of
     opNewVar: i:=teUknownVar;
     else i:=ScanOp(Op,teObjectVarExpected,teEIE);
    end;
    ErrorJump(1,X,Y,i);
   end;
  end; { case }
 end; { with }

 If Back then begin
  TranslateObjExpression:=P; exit
 end;

 With TopTerm^ do begin
  Op:=TermType;
  Case Op of
   opRBra:begin
    If NBraE=0 then
     If NBraL=0 then EJump0(teBraUnnecessary) else TransError:=teBraFromLogic
   end;

   opFunc2:begin { ୠ  }
    If not LeftObj^.IsDefOperator(TermWhat) then EJump0(teOperatorNotEnable);
    Inc(NCalcs);
    K:=NewMemTmp(SizeOf(TTermTree));
    With K^ do begin
     Head:=P;
     TermType:=opFunc2; What:=TermWhat
    end;
    GetTerm;
    Back:=True;
    K^.Tail:=TranslateObjExpression(Back);
    P:=K;
   end;

   opElse..opComma: ;
   else EJump0(teEndExpected)
  end { case }
 end; { with }
 TranslateObjExpression:=P
end;

function TCompilator.CreateModuleCompilator(LibraryName:TermString;
 var LibComp:PCompilator):integer;
{ ᮧ   樨  Library }
begin
 LibComp:=New(P2x2Library,Init(LibraryName+Lib2x2Ext));
 {LibComp^.OwnerCompilator:=@Self;}
 CreateModuleCompilator:=integer(not P2x2Library(LibComp)^.SrcFileExist);
end;

procedure TCompilator.SaveTermsState;
{ ࠭ ६, 室  GetTerm,  ४祭
    Include-䠩 }
var P:PSaveTermBuf;
begin
 New(P);
 With P^ do begin
  OldModule:=CompModule;
  OldModuleType:=CompModuleType;
  OldCurY:=CurY;
  OldDataStr:=DataStr;
  Next:=SaveTB
 end;
 SDataLen:=0; CurStPos:=1; CurY:=0;
 SaveTB:=P;
end;

procedure TCompilator.RestoreTermsState;
{ ⠭ ६, 室  GetTerm, ᫥ 樨 Include-䠩 }
var P:PSaveTermBuf;
begin
 P:=SaveTB;
 With P^ do begin
  CompModule:=OldModule;
  CompModuleType:=OldModuleType;
  CurY:=OldCurY;
  DataStr:=OldDataStr;
 end;
 EOFData:=False;
 SDataLen:=0; CurStPos:=1;
 SaveTB:=P^.Next;
 Dispose(P)
end;

procedure TCompilator.SwitchToIncludeModule(const InclName:string);
{ ४砥    Include-䠩 }
begin
 SaveTermsState;
 CompModule:=InclName;
 CompModuleType:=mtInclude;
 SwitchInclude(sdForward,SaveTB^.UserData);
 GetTerm;
end;

procedure TCompilator.SwitchToMainModule;
{ ४砥   樨 Include-䠩 }
begin
 SwitchInclude(sdBackward,SaveTB^.UserData);
 RestoreTermsState;
 GetTerm;
end;

procedure TCompilator.CompileLibrary(LibraryName:TermString; LibHash:PHashCell);
{  Library }
var SwitchBuf:TSwitchBuffer; x,y,Err:integer; LibComp:PCompilator;
begin
 { ࠭  ॥ࠡ ६ }
 PrepareToSwitchModule(SwitchBuf,mtLibrary);
 { ᮧ   樨  }
 Err:=CreateModuleCompilator(LibraryName,LibComp);
 If Err<>0 then begin { Lib   }
  Dispose(LibComp,Done);
  EJump0(teCantSwitchToLib);
 end;
 CompModule:=LibraryName;
 CompModuleType:=mtLibrary;
 { 㥬  }
 LibComp^.Translate;
 If LibComp^.TransError<>0 then begin
  x:=LibComp^.ErrorX; y:=LibComp^.ErrorY;
  Err:=LibComp^.TransError; ErrorTxt:=LibComp^.ErrorTxt;
  If LibComp^.CompModule<>'MAIN' then CompModule:=LibComp^.CompModule;
  Dispose(LibComp,Done);
  ErrorJump(0,x,y,Err);
 end;
 CompModule:='MAIN';
 CompModuleType:=mtMain;
 {    2x2-Manager }
 If not Manager2x2^.AddLib(LibComp) then begin
  Dispose(LibComp,Done);
  EJump0(teCantAddLibrary);
 end;
 LibHash^.HData:=LibComp;
 LibWPList^.Insert(LibComp);
 { ⠭  ६ }
 SwitchModuleBack(SwitchBuf,mtLibrary);
end;

procedure TCompilator.TransUsesLib(LibHash:PHashCell);
var H:PHashCell; P:PCompilator; b:boolean;
begin
 with LibHash^ do begin
  b:=Manager2x2^.FindLib(Name,H);
  If b then begin
   P:=H^.HData;
   If (csCompiled in P^.State2x2) and not (csNotActual in P^.State2x2) then begin
    HData:=H^.HData;
    LibWPList^.Insert(H^.HData)
   end
   else begin
    b:=False;
    Manager2x2^.DeleteFromGarbage(P);
    Dispose(P,Done);
    H^.HData:=nil
   end
  end;
  If not b then
   If (coCompLib in Options2x2) then CompileLibrary(Name,LibHash)
   else EJump0(teUknownLib);
  Inc(PExprCompilator(HData)^.LibLoadCount)
 end
end;

procedure TCompilator.TranslateList(LMode:ListModeType; UT:OpsType; Coll:PCollection);
var OK,ExpFormat:boolean; OV:POutVar; i1,i2:integer; j:word; S:string[1]; b,IsRef:boolean;
    ObjType:P2x2Object; H:PHashCell;

 procedure AddToExport(H:PHashCell);
 var P:PExportRec;
 begin
  New(P);
  with P^ do begin
   TName:=H^.Name; NHash:=H
  end;
  Exported^.Insert(P)
 end;

 procedure GetFormat(var i:integer);
 var E:Float; cod:integer;
 begin
  GetTerm;
  Case TopTerm^.TermType of
   opComma:;
   opEndData,opSemiColon: OK:=True;
   opColon:begin
    If LMode in [lmStringList,lmUserVarList,lmUserObjList,lmUsesList,
     lmExportList,lmFloatVarList] then EJump0(teCommaExpected);
    GetTerm;
    with TopTerm^ do begin
     If TermType<>opConst then EJump1(teConstExpected);
     E:=PFloat(Ref)^;
     If Frac(E)<>0 then EJump0(teConstExpected);
     If (E<0) or (E>30) then EJump0(teInvFormat);
     i:=Round(E)
    end
   end;
   opEnd,opEndFunc:
    If LMode in [lmUsesList,lmExportList,lmOutList] then OK:=True
    else EJump1(teEndExpected);
   else EJump1(teEndExpected)
  end
 end;

begin
 OK:=False;
 If LMode=lmUserObjList then begin
  ObjType:=PHashCell(TopTerm^.Ref)^.HData;
  GetTerm;
  IsRef:=(TopTerm^.TermType=opFunc2) and (TopTerm^.TermWhat=moPower);
  b:=IsRef;
 end
 else b:=True;

 If LMode=lmExportList then begin
  Repeat
   GetTerm;
   With TopTerm^ do begin
    H:=TopTerm^.Ref;
    case TermType of
     opUserFunc,opUserProc,opFPar..opFConst,opSPar..opSConst,opUserPar,
     opArrayVar..opMatrixVar,opObject,opObjectRef,opObjectType:
      AddToExport(H);
     opRefPar..opRefObjectRef: EJump0(teInvRefFldExport);
     else EJump0(teInvIdExport);
    end;
    AddToExport(H);
   end;
   GetFormat(i1); { ஢塞  opComma }
  until OK;
  exit
 end;

 Repeat
  i1:=$FF; i2:=$FF; ExpFormat:=False;
  j:=0;

  If b then GetTerm;
  With TopTerm^ do begin
   Case TermType of
    opFPar..opFUknown,opFConst: If LMode<>lmOutList then j:=teDoubleName;

    opNewVar:
     Case LMode of
      lmParList:
       If IsDiff then j:=teParDiff else PHashCell(Ref)^.TermType:=opFPar;

      lmStringList:
       If IsDiff then j:=teStringDiff
       else begin
        PHashCell(Ref)^.TermType:=opSUknown;
        PHashCell(Ref)^.ValueP:=NewString(S,False)
       end;

      lmUserVarList:
       If IsDiff then begin
        j:=teUserTypeDiff; ErrorData:=UT
       end
       else
        with PHashCell(Ref)^ do begin
         TermType:=opUserVar; What:=UT;
         ValueF:=0 { ⨯ - - 㫥 - }
        end;

      lmUserObjList:
        with PHashCell(Ref)^ do begin
         What:=UT;
         If IsRef then begin { ꥪ⭠ 뫪 }
          TermType:=opObjectRef; HData:=ObjType
         end
         else begin
          TermType:=opObject;
          If Coll=nil then begin
           HData:=CreateObjInstance(ObjType); { ᮧ ꥪ PUserObject }
           DefColl^.Insert(HData);
          end
          else HData:=ObjType
         end;
         b:=True
        end;

      lmFloatVarList: PHashCell(Ref)^.TermType:=opFUknown;

      lmUsesList: begin
       TransUsesLib(PHashCell(Ref));
       PHashCell(Ref)^.TermType:=opLib;
      end;

      else j:=teUknownVar
     end;

    opArrayVar..opMatrixVar:
     If LMode<>lmOutList then j:=teDoubleName else j:=teStructNotOut;

    opSPar..opSConst:
     If LMode<>lmOutList then j:=teDoubleName else j:=teStringNotOut;

    opUserVar:
     If LMode<>lmOutList then j:=teDoubleName
     else begin
      j:=teUserTypeNotOut; ErrorData:=UT
     end;

    else EJump1(teVarNameExpected)
   end;

   If j<>0 then ErrorJump(0,X,Y,j);
   If LMode in [lmStringList,lmUserVarList,lmUsesList,lmExportList,
    lmUserObjList,lmFloatVarList] then
   begin
    GetFormat(i1); { ஢塞  opComma }
    continue
   end;

   New(OV);
   Coll^.Insert(OV);
   With OV^ do begin
    HVar:=Ref; Diff:=IsDiff
   end
  end;

  GetFormat(i1);
  If TopTerm^.TermType=opConst then GetFormat(i2);

  If i1=$FF then begin
   i1:=stFormat1; i2:=stFormat2
  end
  else
   If i2=$FF then begin
    ExpFormat:=True;
    If i1>26 then i1:=26
    else
     If i1<10 then i1:=10
   end
   else begin
    If i1<2 then i1:=2;
    If i1-i2<2 then i2:=0
   end;

  with OV^ do begin
   Expo:=ExpFormat; F1:=i1; F2:=i2
  end
 until OK
end;

function TCompilator.GetOutNums:word;
begin
 GetOutNums:=OutList^.Count
end;

function TCompilator.GetOutDesc(Num:integer; Var IdDef:TIdDef):boolean;
var P:POutVar;
begin
 If Num>OutList^.Count then GetOutDesc:=False
 else begin
  P:=OutList^.At(Num-1);
  With P^ do begin
   IdDef.Name:=@HVar^.Name;
   IdDef.Value:=@HVar^.ValueF;
   IdDef.F1:=F1; IdDef.F2:=F2
  end;
  GetOutDesc:=True
 end
end;

destructor TCompilator.Done;
var P:PSaveTermBuf;
begin
 If csCompiled in State2x2 then Manager2x2^.UnRegisterCompilator(@Self);
 DoWEP(False);
 Dispose(OutList,Done);
 Dispose(DefsColl,Done);
 Dispose(Exported,Done);
 NotCreated^.DeleteAll;
 Dispose(NotCreated,Done);
 DoneLibs;
 If ProgrammCalcer<>nil then Dispose(ProgrammCalcer,Done);
 While SaveTB<>nil do begin
  P:=SaveTB^.Next;
  SwitchInclude(sdBackward,SaveTB^.UserData);
  Dispose(SaveTB);
  SaveTB:=P
 end;
 Inherited Done;
end;

procedure TCompilator.DoneLibs;
var i:integer; P:PCompilator;
begin
 For i:=0 to LibWPList^.Count-1 do begin {  ᥬ ᯮ㥬  }
  P:=PCompilator(LibWPList^.At(i));
  If P^.UnloadLib then Manager2x2^.DestroyModule(P^.GetModuleName)
 end;
 LibWPList^.DeleteAll;
 Dispose(LibWPList,Done);
end;

function TCompilator.CheckExtern(T:PToken; WhatBlock:byte):boolean;
begin
 CheckExtern:=False
end;

procedure TCompilator.DoWEP(IsInit:boolean);
{ 맮 _InitLib  _DoneLib }
var H:PHashCell; s:TermString;
begin
 If (ProgType=pt2x2Library) and (csCompiled in State2x2) then begin
  If IsInit then s:=_InitLibProc else s:=_DoneLibProc;
  H:=FindHash(s,FuncMask);
  If (H<>nil) and (H^.TermType=opUserProc) then
   PCalcer(PFunction(H^.HData)^.FuncCalc)^.Evaluate
 end
end;

procedure TCompilator.ValidReference(const ValidName:TermString);
var i:integer;
begin
 If (csCompiled in State2x2) and not (csNotActual in State2x2) then begin
  If GetModuleName=ValidName then Include(State2x2,csNotActual);
  For i:=0 to LibWPList^.Count-1 do {  ᥬ ᯮ㥬  }
   PCompilator(LibWPList^.At(i))^.ValidReference(ValidName)
 end
end;

procedure TCompilator.Translate;
var i:integer;
begin
 If csCompiled in State2x2 then begin { ணࠬ 㦥 ⪮஢ }
  TransError:=teProgCompiled; exit
 end;
 If not SrcFileExist then begin { ணࠬ   }
  TransError:=teProgNotOpen; exit
 end;
 TransError:=0;
 Include(State2x2,csCompiling); { ﭨ -  }
 SetJump(JumpPoint);
 If TransError=0 then begin
  DataBlocks:=TranslateBlock(wbGlobal);
  Compile;
  If TransError=0 then begin
   Include(State2x2,csCompiled); { ﭨ - ⪮஢ }
   DoWEP(True);
   For i:=0 to NotCreated^.Count-1 do
    PUserObject(NotCreated^.At(i))^.CallCreate;
   Manager2x2^.RegisterCompilator(@Self)
  end
 end;
 Exclude(State2x2,csCompiling);
 DisposeMemTmp;
end;

procedure TCompilator.Compile;
begin
 CompError.Error:=0;
 CompError.ErrorTxt:='';
 Mask8087(False);
 ProgrammCalcer:=New(PBlockCalcer, Init(DataBlocks,True));
 Mask8087(True);
 If CompError.Error<>0 then begin
  TransError:=CompError.Error;
  ErrorX:=CompError.cX; ErrorY:=CompError.cY;
  ErrorTxt:=CompError.ErrorTxt
 end;
 If (ProgType<>pt2x2Program) or (TransError<>0) then LastFunc:=nil
end;

procedure TCompilator.SetOwnerCompilator(COwner:PCompilator);
var i:integer;
begin
 OwnerCompilator:=COwner;
 For i:=0 to LibWPList^.Count-1 do
  PCompilator(LibWPList^.At(i))^.SetOwnerCompilator(COwner)
end;

procedure TCompilator.Evaluate;
var i:integer;
begin
 If not (csCompiled in State2x2) then begin
  TransError:=teRunNotCompiled; exit { ணࠬ  ⪮஢ }
 end;
 If csNotActual in State2x2 then begin { ணࠬ ᯮ 㠫 㫨 }
  TransError:=teNotActual; exit
 end;
 If ProgType=pt2x2Program then begin
  Include(State2x2,csEvaluating); { ﭨ - 믮 }
  For i:=0 to LibWPList^.Count-1 do { 㢥 㫨 }
   PCompilator(LibWPList^.At(i))^.SetOwnerCompilator(@Self);
  Mask8087(False);
  ProgrammCalcer^.Evaluate;
  Mask8087(True);
  Exclude(State2x2,csEvaluating);
 end
end;

function TCompilator.Calculate:PFloat;
begin
 If LastFunc=nil then Calculate:=nil
 else begin
  Evaluate;
  Calculate:=@LastFunc^.ValueF
 end
end;

procedure TCompilator.NewLine;
begin end;

procedure TCompilator.SwitchInclude(Direction:TSwitchDirection; var Data:pointer);
begin end;

constructor TFileCompilator.Init(const FileName:string);
var Dir:DirStr; Ext:ExtStr; Name:NameStr;
begin
 Inherited Init;
 FSplit(FileName,Dir,Name,Ext);
 SetModuleName(Name);
 Assign(ModuleFile,FileName);
 { 뢠 䠩 ணࠬ }
 Reset(ModuleFile);
 OpenError:=IOResult
end;

procedure TFileCompilator.GetDataString(Var S:string);
begin
 If Eof(ModuleFile) then EOFData:=True else readln(ModuleFile,S)
end;

function TFileCompilator.SrcFileExist:boolean;
begin
 SrcFileExist:=OpenError=0
end;

procedure TFileCompilator.SwitchInclude(Direction:TSwitchDirection; var Data:pointer);
{ ⮤ 뢠, ⮡ 㢥   室 ४
    Include-䠩. ᫥騥 맮 GetDataString 
   ப ணࠬ  Include-䠩 !!!
  Data - 㪠⥫ (樠஢),   ᯮ짮
   ࠭/⠭ -   ४祭 }
type PPascalText=^Text;
begin
 If Direction=sdForward then begin
  { ४砥   Include-䠩 }
  New(PPascalText(Data));
  { ࠭ ⥪ 䠩 ६ }
  FastMove(ModuleFile,PPascalText(Data)^,SizeOf(Text));
  Assign(ModuleFile,CompModule);
  { ஥ Include-䠩 }
  Reset(ModuleFile);
 end
 else begin { ४砥  樨 Include-䠩 }
  { ஥ Include-䠩 }
  Close(ModuleFile);
  { ⠭ । 䠩 ६ }
  FastMove(PPascalText(Data)^,ModuleFile,SizeOf(Text));
  Dispose(PPascalText(Data));
 end;
end;

destructor TFileCompilator.Done;
begin
 If OpenError=0 then Close(ModuleFile);
 Inherited Done
end;

constructor T2x2Compilator.Init(const SrcFile,OutputFile:string);
begin
 Inherited Init(SrcFile);
 OutFileName:=OutputFile;
 Assign(OutFile,OutputFile);
 Rewrite(OutFile);
 StrPrinted:='';
end;

procedure T2x2Compilator.FlushPrintLine;
begin
 writeln(OutFile,StrPrinted);
 StrPrinted:='';
end;

procedure T2x2Compilator.Print(Var S:string);
begin
 StrPrinted:=StrPrinted+S;
end;

destructor T2x2Compilator.Done;
begin
 Close(OutFile);
 Inherited Done
end;

constructor T2x2Library.Init(const FileName:string);
begin
 Inherited Init(FileName);
end;

procedure T2x2Library.FlushPrintLine;
begin
 OwnerCompilator^.FlushPrintLine;
end;

procedure T2x2Library.Print(Var S:string);
begin
 OwnerCompilator^.Print(S);
end;

End.
