{ (c) Copyright 1995,1996 㭨 .. bunin@mes.djug.pyatigorsk.su }
Unit StrFuncs; { ப - }
{$B-}{$F+}{$A+}{$N+}{$R-}{$S-}{$V-}{$I-}{$G+}{$B-}{$X+}{$T-}

Interface
Uses Hash2x2;

Procedure RegisterStrFuncs(Hash:PTermHash);
Procedure DoneStrFuncs;

Implementation
Uses MyString,X1,Diffy,Def2x2,Calcer,UserFunc,TPDate;

Type

 { ࠪ - ப - }
 PStrFunc=^TStrFunc;
 TStrFunc=object(TFuncObject)
  Result:TextTerm; { १- }
  function Register(Hash:PTermhash):boolean;virtual;
 end;

 TLTrim=object(TStrFunc)       { string=LTrim(string) }
  S1:TextTerm;
  HS1:THashCell;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 TRTrim=object(TLTrim)         { string=RTrim(string) }
  procedure Evaluate;virtual;
 end;

 TTrim=object(TLTrim)          { string=Trim(string) }
  procedure Evaluate;virtual;
 end;

 TUpperStr=object(TLTrim)      { string=Upper(string) }
  procedure Evaluate;virtual;
 end;

 TConcat=object(TLTrim)        { string=Concat(string,string) }
  S2:TextTerm;
  HS2:THashCell;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 TSwapSubstr=object(TConcat)   { string=SwapSubStr(string,string,string) }
  S3:TextTerm;
  HS3:THashCell;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 TRPad=object(TLTrim)          { string=RPad(string,byte) }
  H2:THashCell;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 TLPad=object(TRPad)           { string=LPad(string,byte) }
  procedure Evaluate;virtual;
 end;

 TCenter=object(TRPad)           { string=Center(string,byte) }
  procedure Evaluate;virtual;
 end;

 TInsert=object(TConcat)       { string=Insert(string,string,byte) }
  H3:THashCell;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 TFillChar=object(TRPad)       { string=FillChar(string,byte) }
  procedure Evaluate;virtual;
 end;

 TGetChar=object(TRPad)        { string=GetChar(string,byte) }
  procedure Evaluate;virtual;
 end;

 TSetChar=object(TInsert)        { string=SetChar(string,string,byte) }
  procedure Evaluate;virtual;
 end;

 TDelete=object(TRPad)         { string=Delete(string,byte,byte) }
  H3:THashCell;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 TSubStr=object(TDelete)       { string=SubStr(string,byte,byte) }
  procedure Evaluate;virtual;
 end;

 TChar=object(TStrFunc)        { string=Char(byte) }
  H1:THashCell;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 TStr=object(TChar)            { string=Str(float,byte,byte) }
  Hs:array[1..2] of THashCell;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 TStrExp=object(TChar)         { string=StrExp(float,byte) }
  H2:THashCell;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 TLongStr=object(TStrExp)      { string=Long2Str(longint:byte,byte) }
  procedure Evaluate;virtual;
 end;

 TLength=object(TFuncObject)   { byte=Length(string) }
  S1:TextTerm;
  HS1:THashCell;
  constructor Init;
  procedure Evaluate;virtual;
  function Register(Hash:PTermhash):boolean;virtual;
 end;

 TStrToDate=object(TLength)    { word=StrToDate(string) }
  procedure Evaluate;virtual;
 end;

 TPos=object(TLength)          { byte=Pos(string,string) }
  S2:TextTerm;
  HS2:THashCell;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 TWildPos=object(TPos)         { byte=WildPosAfter(string,string,byte) }
  HS3:THashCell;
  constructor Init;
  procedure Evaluate;virtual;
 end;

 TBreakStr=object(TPos)        { byte=BreakStr(string,string) }
  procedure Evaluate;virtual;
 end;

 TBinStr=object(TChar)         { string=Bin(longint) }
  procedure Evaluate;virtual;
 end;

 THexStr=object(TChar)         { string=Hex(longint) }
  procedure Evaluate;virtual;
 end;

 TDateStr=object(TChar)         { string=ToDateStr(Date) }
  procedure Evaluate;virtual;
 end;

 TTimeStr=object(TChar)         { string=ToTimeStr(Time) }
  procedure Evaluate;virtual;
 end;

Const StrFuncNames=28;

Type

 StrName=record
  N:TermString;
  Pars:byte;
 end;

 RStrNameAdr=record
  Cons:pointer;
  VMT:word
 end;
 AStrNameAdr=array[1..StrFuncNames] of RStrNameAdr;
 PStrNameAdr=^AStrNameAdr;

Const
 StrNameAdr:array[1..StrFuncNames] of RStrNameAdr=(
 (Cons:@TLTrim.Init;      VMT:word(TypeOf(TLTrim))),
 (Cons:@TRTrim.Init;      VMT:word(TypeOf(TRTrim))),
 (Cons:@TConcat.Init;     VMT:word(TypeOf(TConcat))),
 (Cons:@TRPad.Init;       VMT:word(TypeOf(TRPad))),
 (Cons:@TLPad.Init;       VMT:word(TypeOf(TLPad))),
 (Cons:@TInsert.Init;     VMT:word(TypeOf(TInsert))),
 (Cons:@TFillChar.Init;   VMT:word(TypeOf(TFillChar))),
 (Cons:@TGetChar.Init;    VMT:word(TypeOf(TGetChar))),
 (Cons:@TSetChar.Init;    VMT:word(TypeOf(TSetChar))),
 (Cons:@TDelete.Init;     VMT:word(TypeOf(TDelete))),
 (Cons:@TChar.Init;       VMT:word(TypeOf(TChar))),
 (Cons:@TStr.Init;        VMT:word(TypeOf(TStr))),
 (Cons:@TStrExp.Init;     VMT:word(TypeOf(TStrExp))),
 (Cons:@TTrim.Init;       VMT:word(TypeOf(TTrim))),
 (Cons:@TLength.Init;     VMT:word(TypeOf(TLength))),
 (Cons:@TPos.Init;        VMT:word(TypeOf(TPos))),
 (Cons:@TBinStr.Init;     VMT:word(TypeOf(TBinStr))),
 (Cons:@THexStr.Init;     VMT:word(TypeOf(THexStr))),
 (Cons:@TSubStr.Init;     VMT:word(TypeOf(TSubStr))),
 (Cons:@TDateStr.Init;    VMT:word(TypeOf(TDateStr))),
 (Cons:@TTimeStr.Init;    VMT:word(TypeOf(TTimeStr))),
 (Cons:@TLongStr.Init;    VMT:word(TypeOf(TLongStr))),
 (Cons:@TCenter.Init;     VMT:word(TypeOf(TCenter))),
 (Cons:@TSwapSubstr.Init; VMT:word(TypeOf(TSwapSubstr))),
 (Cons:@TBreakStr.Init;   VMT:word(TypeOf(TBreakStr))),
 (Cons:@TUpperStr.Init;   VMT:word(TypeOf(TUpperStr))),
 (Cons:@TWildPos.Init;    VMT:word(TypeOf(TWildPos))),
 (Cons:@TStrToDate.Init;  VMT:word(TypeOf(TStrToDate))));

Const

 StrNames:array[1..StrFuncNames] of StrName=(
  (N:'LTRIM'      ; Pars:1  ),
  (N:'RTRIM'      ; Pars:1  ),
  (N:'CONCAT'     ; Pars:2  ),
  (N:'RPAD'       ; Pars:2  ),
  (N:'LPAD'       ; Pars:2  ),
  (N:'INSERT'     ; Pars:3  ),
  (N:'FILLCHAR'   ; Pars:2  ),
  (N:'GETCHAR'    ; Pars:2  ),
  (N:'SETCHAR'    ; Pars:2  ),
  (N:'DELETE'     ; Pars:3  ),
  (N:'CHAR'       ; Pars:1  ),
  (N:'STR'        ; Pars:3  ),
  (N:'STREXP'     ; Pars:2  ),
  (N:'TRIM'       ; Pars:1  ),
  (N:'LENGTH'     ; Pars:1  ),
  (N:'POS'        ; Pars:2  ),
  (N:'BINSTR'     ; Pars:1  ),
  (N:'HEXSTR'     ; Pars:1  ),
  (N:'SUBSTR'     ; Pars:3  ),
  (N:'STRDATE'    ; Pars:1  ),
  (N:'STRTIME'    ; Pars:1  ),
  (N:'LONGSTR'    ; Pars:2  ),
  (N:'CENTER'     ; Pars:2  ),
  (N:'SWAPSUBSTR' ; Pars:3  ),
  (N:'BREAKSTR'   ; Pars:2  ),
  (N:'UPPERSTR'   ; Pars:1  ),
  (N:'WILDPOS'    ; Pars:3  ),
  (N:'STRTODATE'  ; Pars:1  )
 );

Function TStrFunc.Register(Hash:PTermHash):boolean;
Var B:boolean;
Begin
 B:=Inherited Register(Hash);
 Register:=B;
 If not B then exit;
 With H^ do begin
  ValueP:=@Result; TermType:=opStringFunc;
 end;
End;

Constructor TLTrim.Init;
Begin
 Inherited Init;
 With F.Pars[1] do begin
  TermType:=opStringVar; Hash:=@HS1
 end;
 HS1.ValueP:=@S1
End;

Procedure TLTrim.Evaluate;
Begin
 Result:=S1;
 FastTrimHead(Result)
End;

Procedure TRTrim.Evaluate;
Begin
 Result:=S1;
 FastTrimEnd(Result)
End;

Procedure TTrim.Evaluate;
Begin
 Result:=S1;
 FastTrim(Result)
End;

Procedure TUpperStr.Evaluate;
Begin
 Result:=UpperCase(S1);
End;

Constructor TConcat.Init;
Begin
 Inherited Init;
 With F.Pars[2] do begin
  TermType:=opStringVar; Hash:=@HS2
 end;
 HS2.ValueP:=@S2
End;

Procedure TConcat.Evaluate;
Begin
 Result:=S1+S2
End;

Constructor TSwapSubstr.Init;
Begin
 Inherited Init;
 With F.Pars[3] do begin
  TermType:=opStringVar; Hash:=@HS3
 end;
 HS3.ValueP:=@S3
End;

Procedure TSwapSubstr.Evaluate;
Var Enough:boolean;
Begin
 Result:=S1;
 SwapSubstring(Result,S2,S3,Enough,250);
End;

Constructor TRPad.Init;
Begin
 Inherited Init;
 With F.Pars[2] do begin
  TermType:=opVar; Hash:=@H2
 end
End;

Procedure TRPad.Evaluate;
Begin
 Result:=RPad(S1,Round(H2.Value))
End;

Procedure TLPad.Evaluate;
Begin
 Result:=LPad(S1,Round(H2.Value))
End;

Procedure TCenter.Evaluate;
Begin
 Result:=CenterStr(S1,Round(H2.Value),' ')
End;

Constructor TInsert.Init;
Begin
 Inherited Init;
 With F.Pars[3] do begin
  TermType:=opVar; Hash:=@HS2
 end
End;

Procedure TInsert.Evaluate;
Begin
 Result:=S1;
 Insert(Result,S2,Round(H3.Value))
End;

Procedure TFillChar.Evaluate;
Var I:byte;
Begin
 I:=MinI(Round(H2.Value),TextTermSize-1);
 Result[0]:=chr(I);
 FillChar(Result[1],I,S1[1])
End;

Procedure TGetChar.Evaluate;
var i:byte;
Begin
 i:=Round(H2.value);
 If Length(S1)>=i then Result:=S1[i] else Result:=''
End;

Procedure TSetChar.Evaluate;
var i:byte;
Begin
 Result:=S1;
 i:=Round(H3.Value);
 If Length(S1)>=i then Result[i]:=S2[1]
End;

Constructor TDelete.Init;
Begin
 Inherited Init;
 With F.Pars[3] do begin
  TermType:=opVar; Hash:=@H3
 end
End;

Procedure TDelete.Evaluate;
Begin
 Result:=S1;
 Delete(Result,Round(H2.Value),Round(H3.Value))
End;

Procedure TSubStr.Evaluate;
Begin
 Result:=Copy(S1,Round(H2.Value),Round(H3.Value))
End;

Constructor TChar.Init;
Begin
 Inherited Init;
 With F.Pars[1] do begin
  TermType:=opVar; Hash:=@H1
 end
End;

Procedure TChar.Evaluate;
Begin
 Result:=chr(Round(H1.Value))
End;

Procedure TDateStr.Evaluate;
Var D,M,Y:integer; Dt:Date;
Begin
 Dt:=Round(H1.Value);
 If Dt=BadDate then Result:=''
 else begin
  DateToDMY(Dt,D,M,Y);
  Result:=ToDateStr(D,M,Y-1900);
 end;
End;

Procedure TTimeStr.Evaluate;
Var W:word;
Begin
 W:=Round(H1.Value);
 Result:=ToTimeStr(W shr 8,W and $00FF)
End;

Constructor TStr.Init;
Var I:byte;
Begin
 Inherited Init;
 For I:=1 to 2 do With F.Pars[I] do begin
  TermType:=opVar; Hash:=@Hs[I]
 end
End;

Procedure TStr.Evaluate;
Begin
 Str(H1.Value:Round(Hs[1].Value):Round(Hs[2].Value),Result)
End;

Constructor TStrExp.Init;
Begin
 Inherited Init;
 With F.Pars[2] do begin
  TermType:=opVar; Hash:=@H2
 end
End;

Procedure TStrExp.Evaluate;
Begin
 Str(H1.Value:Round(H2.Value),Result)
End;

Procedure TLongStr.Evaluate;
Var V:longint; Width:byte;
Begin
 V:=Round(H1.Value);
 Width:=Round(H2.Value);
 If Width=0 then Str(V,Result) else Str(V:Width,Result)
End;

Constructor TLength.Init;
Begin
 Inherited Init;
 With F.Pars[1] do begin
  TermType:=opStringVar; Hash:=@HS1
 end;
 HS1.ValueP:=@S1;
End;

Procedure TLength.Evaluate;
Begin
 H^.Value:=Length(S1)
End;

Procedure TStrToDate.Evaluate;
Var D:Date;
Begin
 FlipChar(S1,'.','/');
 D:=DateStringToDate('dd/mm/yy',S1);
 H^.Value:=word(D)
End;

Function TLength.Register(Hash:PTermHash):boolean;
Var B:boolean;
Begin
 B:=Inherited Register(Hash);
 Register:=B;
 If B then H^.TermType:=opUserFunc;
End;

Constructor TPos.Init;
Begin
 Inherited Init;
 With F.Pars[2] do begin
  TermType:=opStringVar; Hash:=@HS2
 end;
 HS2.ValueP:=@S2;
End;

Procedure TPos.Evaluate;
Begin
 H^.Value:=Pos(S1,S2)
End;

Constructor TWildPos.Init;
Begin
 Inherited Init;
 With F.Pars[3] do begin
  TermType:=opVar; Hash:=@HS3
 end
End;

Procedure TWildPos.Evaluate;
Var After:byte;
Begin
 After:=Round(HS3.Value);
 H^.Value:=WildPosAfter(S1,S2,After)
End;

Procedure TBreakStr.Evaluate;
Begin
 H^.Value:=BreakStr(S1,S2)
End;

Procedure TBinStr.Evaluate;
Begin
 Result:=BinLong(Round(H1.Value))
End;

Procedure THexStr.Evaluate;
Var L:longint; S:string[6];
Begin
 L:=Round(H1.Value);
 S:=WHex(Hi(L));
 Dec(S[0]);
 Result:=S+WHex(Lo(L));
End;

Function NewStrFunc(VMT:word; ConsAddr:pointer):pointer;assembler;
asm
 push VMT
 xor ax,ax
 push ax
 push ax
 call [ConsAddr]
End;

Procedure InitStrFuncs;
Var I:word;
Begin
 For I:=1 to StrFuncNames do begin
  StrNameAdr[I].Cons:=NewStrFunc(StrNameAdr[I].VMT, StrNameAdr[I].Cons);
  with PStrFunc(StrNameAdr[I].Cons)^ do begin
   Name:=StrNames[I].N;
   F.NPars:=StrNames[I].Pars;
   F.SimpleIfAllConst:=True
  end
 end
End;

Procedure DoneStrFuncs;
Var I:word;
Begin
 For I:=1 to StrFuncNames do Dispose(PCalcer(StrNameAdr[I].Cons),Done)
End;

Procedure RegisterStrFuncs(Hash:PTermHash);
Var I:word;
Begin
 For I:=1 to StrFuncNames do PStrFunc(StrNameAdr[I].Cons)^.Register(Hash)
End;

Begin
 InitStrFuncs;
End.